/*
 * u9a2_suchbaum.cpp - Informatik I, D-ITET
 * Nicky Kern, 30.1.2003
 * Bruno Heidelberger, 12.1.2004
 */

#include <iostream>
#include <string.h>

// define the structs for the tree and the nodes
struct treeNode {
	char* name;
	treeNode *left, *right;
};

struct treeRoot {
	treeNode *first;
};

// create a new tree
treeRoot* newTree() 
{
	
	treeRoot *root = new treeRoot;
	root->first = NULL;
	return root;
}

// create a new node
treeNode* newNode(char* s)
{
	treeNode* n = new treeNode;

	n->name = new char[strlen(s)+1];
	strcpy(n->name, s);

	n->left = n->right = 0;
	return n;
}

// add a new value under an existing node
void addToNode(treeNode* oldNode, char* name)
{
	int result = strcmp(name, oldNode->name);

	if (result < 0) {
		if (oldNode->left) addToNode(oldNode->left, name);
		else oldNode->left = newNode(name);
	} else if (result > 0) {
		if (oldNode->right) addToNode(oldNode->right, name);
		else oldNode->right = newNode(name);
	}
}

// insert a value into the tree
void insert(treeRoot* tree, char* s)
{
	if (tree->first) addToNode(tree->first, s);
	else tree->first = newNode(s);
}

// delete a node
void deleteNode(treeNode *node)
{
  if(node->left) deleteNode(node->left);
  if(node->right) deleteNode(node->right);
  delete [] node->name;
}

// delete the whole tree
void deleteTree(treeRoot *root)
{
  if(root->first) deleteNode(root->first);
  delete root;
}

// recursively print the data in the tree
void printNode(treeNode* n, int level)
{
	if (n->left) printNode(n->left, level + 1);
	cout << level << ": " << n->name << endl;
	if (n->right) printNode(n->right, level + 1);
}

// recursively search a given value (not asked in exercise)
treeNode* search(treeRoot* tree, char* s)
{
	treeNode* n = tree->first;
	while (n) {

		int result = strcmp(n->name, s);
		if (result < 0) {
			n = n->left;
		} else if (result > 0) {
			n = n->right;
		} else {
			return n;
		}
	}

	return 0;
}

// the main function
int main()
{
  // create an empty tree
	treeRoot *tree = newTree();

  // insert the values into the tree
	insert(tree, "Hallo");
	insert(tree, "Du");
	insert(tree, "Alter");
	insert(tree, "Hund");
	
  // do some searching (not asked)
	if (search(tree, "Halo")) cout << "Halo gefunden!";
	else cout << "Halo nicht gefunden!";
	cout << endl;
	
	if (search(tree, "Hallo")) cout << "Hallo gefunden!";
	else cout << "Hallo nicht gefunden!";
	cout << endl;

  // print the content of the tree
	printNode(tree->first, 1);

  // delete the tree and all its data
  deleteTree(tree);
}
